#define A0 A0
#define A3 A3
#define A2 A2
#include <wiring_private.h>
#include <pins_arduino.h>
#define D2 2
#define D5 5
#define D4 4
#define D3 3
#define D7 7
#define D6 6
#define D9 9
#define D8 8
#include <SoftwareSerial.h>
#define D13 13
#define D12 12
#include <Servo.h>

/***   Global variables   ***/
int state=0;
volatile int receiveData=0;
volatile int getBite=0;
int command = 0;
long distUS=0;
int posX = 75;
int posY = 75;
int vMan = 0;
int wMan = 0;
int pinza = 0;
bool connection = false;
bool evitarObst = false;
bool pararObst = false;
bool reaccSonid = false;

SoftwareSerial _bt_device(8,9);
Servo _servoD13;
Servo _servoD12;
Servo _servoD7;
Servo _servoD6;


int velLin[13] = {100, 70, 50, 30, 20, 10, 0, -10, -20, -30, -50, -70, -100};
int velAng[13] = {-58, -31, -11, -4, -4, -3, -3, -3, -1, 0, 7, 22, 38};
int vmax = 70;
int wmax = 70;
volatile float lumR=0;
volatile float lumL=0;

const uint16_t SEVEN_NATIONS_ARMY[] = {330,759,330,252,392,378,330,125,0,252,294,252,262,1012,245,1012,330,759,330,252,392,378,330,125,0,252,294,252,262,506,294,252,262,252,245,1012,330,759,330,252,392,378,330,125,0,252,294,252,262,1012,245,1012};
volatile uint16_t* _current_melody_ptr;
volatile int _melody_pin=0;
volatile int _melody_counter=0;
volatile int _melody_length=0;
volatile uint8_t _melody_status=-1;
volatile unsigned long _melody_next_time=0;
unsigned long _currentTime;

/***   Function declaration   ***/
void move_base_D13_D12(int speed, int advance, int turn);

/***   Class declaration   ***/

/***   Tasks declaration   ***/
SIGNAL (TIMER0_COMPA_vect){
playMelodyInterrupt();
}

/***   ISR function declaration   ***/

/***   Additional Global variables   ***/

void setup()
{
  lumR=pow(10,illuminance(analogRead(A7)));
  lumL=pow(10,illuminance(analogRead(A6)));
  
  Serial.begin(9600);

  pinMode((A3),INPUT);
  pinMode((A2),OUTPUT);
  pinMode(D8,INPUT);
  pinMode(D9, OUTPUT);
  _bt_device.begin(9600);
  _bt_device.flush();

  _bt_device.flush();
  String name = "SapoBot";
  String str = "AT\r\nAT\r\nAT+NAME"+name+"\r\n";
  _bt_device.write(str.c_str());


  _servoD7.attach(D7);
  _servoD6.attach(D6);
  movePinza(0);
  _servoD13.attach(D13);
  _servoD12.attach(D12);
  move_base_D13_D12(100,0,0);
  

  pinMode(D4,OUTPUT);

  pinMode(D5,OUTPUT);

  pinMode(D3,OUTPUT);

  maxAll(D4,D5,D3,11,7);
  maxAll(D4,D5,D3,9,0);
  maxAll(D4,D5,D3,12,1);
  maxAll(D4,D5,D3,15,0);
  int i=0;
  for (i = 1; i <= 8; i++)
  maxAll(D4,D5,D3,i,0);
  maxAll(D4,D5,D3,10,15);

  OCR0A=0xAF;
  TIMSK0 |= _BV(OCIE0A);
}


void loop()
{
    distUS=distance((A2),(A3));
    if (_bt_device.available() > 0) {
        if (connection == false){
          _tone(D2,659.26,50,30);
          _tone(D2,1318.51,55,25);
          _tone(D2,1760,60,10);
        }
        Serial.println(connection);
        connection = true;
        receiveData=_bt_device.read();
        getBite = getBite + 1;
        if (receiveData == 5) {
      getBite=1;
     }

     switch (getBite) {
      case 2:
        command = receiveData;
        break;
      case 3:
        posX = receiveData;
        break;
      case 4:
        posY = receiveData;
        break;
     }

        if (getBite == 4) {
          switch (command) {
            case 1:
              move_base_D13_D12(100,0,0);
              state =1;
              break;
            case 2:
              move_base_D13_D12(100,0,0);
              state = 2;
              break;
            case 3:
              move_base_D13_D12(100,0,0);
              state=3;
              break;
            case 10:
              move_base_D13_D12(100,0,0);
              state=0;
              break;
            case 11:
              if (evitarObst == false) {
                evitarObst = true;
              } else {
                evitarObst = false;
              }
              break;
            case 12:
              if (pararObst == false) {
                pararObst = true;
              } else {
                pararObst = false;
              }
              break;
            case 13:
              if (reaccSonid == false) {
                reaccSonid = true;
              } else {
                reaccSonid = false;
              }
              break;
          }
          //Serial.println(command);
            
          
          switch (state){
            case 1:
              manual();
              break;
            case 2:
              progLine();
              break;
            case 3:
              progLum();
              break;
          }
      
     }

     
     }
}

/***   Function definition   ***/


void manual(){
      switch (command){
        case 23:
          if (pinza!=1){
            movePinza(1);
          } else {
            movePinza(-1);
          }
          break;
        case 24:
          prepareMelody(D2,SEVEN_NATIONS_ARMY,sizeof(SEVEN_NATIONS_ARMY)/(2*sizeof(uint16_t)));
          break;
        case 81:
          expression(D4,D5,D3,0,0,0,0,0,0,0,0);
          break;
        case 82:
          expression(D4,D5,D3,48,24,12,12,12,12,24,48);
          break;
        case 83:
          expression(D4,D5,D3,64,34,36,8,8,36,34,64);
          break;
        case 84:
          expression(D4,D5,D3,12,24,48,48,48,48,24,12);
          break;
        case 85:
          expression(D4,D5,D3,48,120,124,62,62,124,120,48);
          break;
        case 86:
          expression(D4,D5,D3,8,19,238,124,124,238,19,8);
          break;
        case 87:
          expression(D4,D5,D3,97,154,47,52,52,47,154,97);
          break;
        case 88:
          expression(D4,D5,D3,12,219,118,52,52,118,219,12);
          break;
        case 89:
          expression(D4,D5,D3,0,28,42,73,85,73,42,28);
          break;
      }
      vMan = (75-posY)*100/75;
      wMan = (75-posX)*100/75;
      if(abs(vMan)<10) {
        vMan = 0;
      }
      if(abs(wMan)<10) {
        wMan = 0;
      }
      else if(vMan<0){
        wMan=(-1)*wMan;
      }
      if (evitarObst == true && distUS<=5){
        move_base_D13_D12(50,0,40);
        delay(700);
        move_base_D13_D12(50,0,0);
      }
      if (pararObst == true && distUS<=4){
        vMan = 0;
      } else if (pararObst == true && distUS<=15) {
        int vMano = vMan;
        vMan = (distUS-2)/11*vMan;
        wMan = wMan-wMan*(vMano-vMan)/(2*vMano);
      }
      move_base_D13_D12(50,vMan,wMan);
}

void progLine() {
    int v = 30;
    int w =follow(analogRead(A0),-20);
    if (pararObst == true && distUS<=4){
        v = 0;
      } else if (pararObst == true && distUS<=15) {
        int vo = v;
        v = (distUS-2)/11*vMan;
        w = w-w*(vo-v)/(2*vo);
      }
    move_base_D13_D12(20,v,w);
}

void progLum() {
  expression(D4,D5,D3,0,0,0,0,0,0,0,0);
  int v = 0;
  int wraw = 0;
  int w = 0;
  lumR=pow(10,illuminance(analogRead(A7)));
  lumL=pow(10,illuminance(analogRead(A6)));
  if (lumR <=40 || lumL <= 40){
    wraw = (lumR-lumL)/max(lumR,lumL)/2 * wmax;
    v = vmax;
  }
  Serial.println(lumR);
  Serial.println(lumL);
  if (wraw > 5) {
    w = 30 + wraw;
  } else if (wraw < -5) {
    w = -40 + wraw;
  } else {
    w = interpolvel(v, 0);
  }
  if (evitarObst == true && distUS<=5){
        move_base_D13_D12(50,0,40);
        delay(700);
        move_base_D13_D12(50,0,0);
      }
      if (pararObst == true && distUS<=4){
        v = 0;
      } else if (pararObst == true && distUS<=15) {
        int vo = v;
        v = (distUS-3)/11*v;
        w = w-w*(vo-v)/(2*vo);
      }
  move_base_D13_D12(100,v,w);
  delay(10);
}

void movePinza (int posPinza) {
  switch (posPinza){
    case -1:
      pinza = -1;
      _servoD7.write(126);
      _servoD6.write(66);
      break;
    case 0:
      pinza = 0;
      _servoD7.write(97);
      _servoD6.write(101);
      break;
    case 1:
      pinza = 1;
      _servoD7.write(60);
      _servoD6.write(138);
      break;
  }
}

void move_base_D13_D12(int speed, int advance, int turn)
{
_servoD13.write(90+(int)(65.0*(float)(speed*(advance-turn))/10000.0));
_servoD12.write(90-(int)(65.0*(float)(speed*(advance+turn))/10000.0));
};

int interpolvel(int vraw, int wraw){
  int i = 0;
  while (vraw < velLin[i]){
    i++;
  }
  int w = round(wraw + velAng[i-1] + (vraw-velLin[i-1]) * (velAng[i]-velAng[i-1])/(velLin[i]-velLin[i-1]) );
  //if(w>100){w=100;}
  //else if (w<-100){w=-100;}
  return w;
}

float rational(float x, float a, float b, float c, float d){
 return (a+b*x)/(1.0+c*x+d*x*x);
}
float illuminance (float LDR) {
float logLDR=log(LDR)/log(10);
  float
logLux=rational(logLDR,0.60520301477,-0.199225473,-0.602130415,0.0897771308217);
  return logLux;
 }

 void LEDMatrix_init(int cs, int din, int clk) {
maxAll(cs,din,clk,11,7);
maxAll(cs,din,clk,9,0);
maxAll(cs,din,clk,12,1);
maxAll(cs,din,clk,15,0);
int i=0;
for (i = 1; i <= 8; i++) {
maxAll(cs,din,clk,i, 0);
}
maxAll(cs,din,clk,10,15);
}
void writeRow(int cs, int din, int clk, int row, int data) {
digitalWrite(cs,LOW);
putByte(din,clk,row);
putByte(din,clk,data);
digitalWrite(cs,LOW);
digitalWrite(cs,HIGH);
}
void maxAll (int cs, int din, int clk, int reg, int col) {
digitalWrite(cs,LOW);
putByte(din,clk,reg);
putByte(din,clk,col);
digitalWrite(cs,LOW);
digitalWrite(cs,HIGH);
}
void putByte (int din, int clk, int data) {
byte i = 8;
byte mask;
while(i > 0) {mask = 0x01 << (i - 1);
 digitalWrite(clk,LOW);
  if (data & mask)
{
    digitalWrite(din,HIGH);
  }else{
    digitalWrite(din,LOW);
  }
  digitalWrite(clk,HIGH);
  --i;
}
}
void expression(int cs, int din, int clk, int col1, int col2, int col3, int col4, int col5, int col6, int col7, int col8) {
writeRow(cs,din,clk,1, col1);
writeRow(cs,din,clk,2, col2);
writeRow(cs,din,clk,3, col3);
writeRow(cs,din,clk,4, col4);
writeRow(cs,din,clk,5, col5);
writeRow(cs,din,clk,6, col6);
writeRow(cs,din,clk,7, col7);
writeRow(cs,din,clk,8, col8);
}

void prepareMelody(int pin,const uint16_t* melody, int length)
{
  if (_melody_status==1)
  return;
  _melody_pin=pin;
  _current_melody_ptr=(uint16_t*)melody;
  _melody_length=length;
  _melody_counter=0;
  noTone(_melody_pin);
  _melody_next_time=millis()+2;
  _melody_status=1;
}
void playMelodyInterrupt()
{
  unsigned int _melody_note=0;
  unsigned long _melody_duration=0;
  unsigned long currentTime=millis();
   if (_melody_status==0)
 {
  noTone(_melody_pin);
  _melody_status=-1;
 }
 else if (_melody_status==1){
  if (_melody_counter>_melody_length)
  {
  _melody_status=0;
  }
  if (currentTime>=_melody_next_time)
  {
  _melody_note=*_current_melody_ptr++;
  _melody_duration=*_current_melody_ptr++;
  tone(_melody_pin,_melody_note,_melody_duration);
  _melody_next_time=currentTime+_melody_duration;
  _melody_counter++;
  }
 }
}
void _tone(int buzzerPin, float noteFrequency, long noteDuration, int silentDuration){
  tone(buzzerPin, noteFrequency, noteDuration);
  delay(noteDuration);
  delay(silentDuration);
}
void bendTones (int buzzerPin, float initFrequency, float finalFrequency, float prop, long noteDuration, int silentDuration){
  if(initFrequency < finalFrequency){
  for (int i=initFrequency; i<finalFrequency; i=i*prop) {
    _tone(buzzerPin,i,noteDuration,silentDuration);
  }
  }  else{
  for (int i=initFrequency; i>finalFrequency; i=i/prop) {
    _tone(buzzerPin,i,noteDuration,silentDuration);
}
}
}

unsigned long _pulseIn(uint8_t pin, uint8_t state, unsigned long timeout)
{
  uint8_t bit = digitalPinToBitMask(pin);
  uint8_t port = digitalPinToPort(pin);
  uint8_t stateMask = (state ? bit : 0);
  unsigned long width = 0;
  unsigned long numloops = 0;
  unsigned long maxloops = microsecondsToClockCycles(timeout) / 16;
  while ((*portInputRegister(port) & bit) == stateMask)
 if (numloops++ == maxloops)
    return 0;
  while ((*portInputRegister(port) & bit) != stateMask)
  if (numloops++ == maxloops)
    return 0;
  while ((*portInputRegister(port) & bit) == stateMask) {
  if (numloops++ == maxloops)
    return 0;
  width++;
  }
  return clockCyclesToMicroseconds(width * 21 + 16);
}
long US_init(int trigger_pin, int echo_pin)
{
  digitalWrite(trigger_pin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigger_pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigger_pin, LOW);
  long microseconds = _pulseIn(echo_pin ,HIGH,100000);
  return microseconds;
}
long distance(int trigger_pin, int echo_pin)
{
  long microseconds = US_init(trigger_pin, echo_pin);
  long distance;
  distance = microseconds/29/2;
  if (distance == 0){
  distance = 999;
  }
  return distance;
}

int follow(int light, int gain)
{
  return (int)(((float)(gain)/100.0)*((float)((400-30)/2+30)-(float)(light)));
}
